/*
 * caterpillar.java
 *
 * Created on 26. srpen 2003, 22:21
 */

import java.awt.*;
/** Main class for the game Caterpillar. Inherits Applet.
 * @author Pavel
 */
public class CaterpillarForm extends java.applet.Applet implements Runnable
{
    private Thread timer;
    private boolean paused = false;
    
    private Grid grid;
    private boolean gridResized;
    private Caterpillar caterpillar;
    private int caterpillarSpeed;
    private int caterpillarSpeedTime;
    private int numberOfBarriers;
    private boolean canMove = false;
    
    /** Initializes the applet caterpillar, overrides Applet.init() */
    public void init()
    {
        initComponents();
        myInit();
    }
    
    private void myInit()
    {
        widthText.setText("20");
        heightText.setText("20");
        speedText.setText("5");
        speedTextOnFocusLost(null);
        barriersText.setText("20");
        numberOfBarriers = 20;
        
        grid = new Grid(20, 20);
        gridResized = true;
        caterpillar = null;
        
        startButton.requestFocusInWindow();
        repaint();
    }
    
    private static int max(int x, int y)
    {
        if (x < y)
            return y;
        else
            return x;
    }
    
    /** Call this method if repainting the form is needed.
     * @param g Graphics object
     */    
    public void paint(Graphics g)
    {
        errorLabel.setSize(this.getSize().width - 20, errorLabel.getHeight());
        resize(grid.GetWidthPixels() + 150 + 30, max(grid.GetHeightPixels() + 30 + errorLabel.getHeight() + errorLabel.getY(), 250));
        grid.Paint(this.getBackground(), g, 150, errorLabel.getHeight() + errorLabel.getY());
            
        if (gridResized)
        {
            if (caterpillar != null)
            {
                caterpillar.Delete(g);
                caterpillar = null;
            }
            gridResized = false;
        }
        
        if (caterpillar != null)
            caterpillar.paint(g);
    }
    
    /** Called by environment if updating (here means only repainting) of applet form is
     * needed. Simply calls <CODE>paint(Graphics)</CODE> method.
     * @param g Graphics object to pass <CODE>paint()</CODE> method.
     */    
    public void update(Graphics g)
    {
        paint(g);
    }
    
    /** This method is called from within the init() method to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        controlsPanel = new java.awt.Panel();
        widthLabel = new java.awt.Label();
        widthText = new java.awt.TextField();
        heightLabel = new java.awt.Label();
        heightText = new java.awt.TextField();
        speedLabel = new java.awt.Label();
        speedText = new java.awt.TextField();
        barriersLabel = new java.awt.Label();
        barriersText = new java.awt.TextField();
        startButton = new java.awt.Button();
        stopButton = new java.awt.Button();
        pauseButton = new java.awt.Button();
        errorLabel = new java.awt.Label();

        setLayout(null);

        addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                formKeyPressed(evt);
            }
        });

        controlsPanel.setLayout(null);

        widthLabel.setText("Width:");
        controlsPanel.add(widthLabel);
        widthLabel.setBounds(40, 10, 38, 20);

        widthText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                widthTextOnFocusLost(evt);
            }
        });
        widthText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                widthTextKeyPressed(evt);
            }
        });

        controlsPanel.add(widthText);
        widthText.setBounds(90, 10, 40, 20);

        heightLabel.setText("Height:");
        controlsPanel.add(heightLabel);
        heightLabel.setBounds(40, 40, 40, 20);

        heightText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                heightTextOnFocusLost(evt);
            }
        });
        heightText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                heightTextKeyPressed(evt);
            }
        });

        controlsPanel.add(heightText);
        heightText.setBounds(90, 40, 40, 20);

        speedLabel.setText("Speed:");
        controlsPanel.add(speedLabel);
        speedLabel.setBounds(40, 70, 40, 20);

        speedText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                speedTextOnFocusLost(evt);
            }
        });
        speedText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                speedTextKeyPressed(evt);
            }
        });

        controlsPanel.add(speedText);
        speedText.setBounds(90, 70, 40, 20);

        barriersLabel.setText("# of barriers:");
        controlsPanel.add(barriersLabel);
        barriersLabel.setBounds(10, 100, 70, 20);

        barriersText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                barriersTextOnFocusLost(evt);
            }
        });
        barriersText.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                barriersTextKeyPressed(evt);
            }
        });

        controlsPanel.add(barriersText);
        barriersText.setBounds(90, 100, 40, 20);

        startButton.setLabel("Start");
        startButton.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                startButtonKeyPressed(evt);
            }
        });
        startButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                startButtonOnClick(evt);
            }
        });

        controlsPanel.add(startButton);
        startButton.setBounds(30, 130, 90, 24);

        stopButton.setEnabled(false);
        stopButton.setLabel("Stop");
        stopButton.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                stopButtonKeyPressed(evt);
            }
        });
        stopButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                stopButtonOnClick(evt);
            }
        });

        controlsPanel.add(stopButton);
        stopButton.setBounds(30, 160, 90, 24);

        pauseButton.setEnabled(false);
        pauseButton.setLabel("Pause");
        pauseButton.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                pauseButtonKeyPressed(evt);
            }
        });
        pauseButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                pauseButtonOnClick(evt);
            }
        });

        controlsPanel.add(pauseButton);
        pauseButton.setBounds(30, 190, 90, 24);

        add(controlsPanel);
        controlsPanel.setBounds(0, 30, 150, 220);

        errorLabel.setFont(new java.awt.Font("Dialog", 1, 12));
        errorLabel.setForeground(new java.awt.Color(255, 0, 0));
        add(errorLabel);
        errorLabel.setBounds(10, 10, 120, 20);

    }//GEN-END:initComponents

    private void speedTextOnFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_speedTextOnFocusLost
        errorLabel.setText("");
        try
        {
            int newSpeedText = Integer.parseInt(speedText.getText());

            if ((newSpeedText < 1) || (newSpeedText > 10))
                errorLabel.setText("Speed must be number 1 - 10.");
            else
                switch (caterpillarSpeed = newSpeedText)
                {
                    case 1:  caterpillarSpeedTime = 500; break;
                    case 2:  caterpillarSpeedTime = 350; break;
                    case 3:  caterpillarSpeedTime = 250; break;
                    case 4:  caterpillarSpeedTime = 180; break;
                    case 5:  caterpillarSpeedTime = 130; break;
                    case 6:  caterpillarSpeedTime = 100; break;
                    case 7:  caterpillarSpeedTime = 80; break;
                    case 8:  caterpillarSpeedTime = 67; break;
                    case 9:  caterpillarSpeedTime = 53; break;
                    case 10: caterpillarSpeedTime = 45; break;
                }
        }
        catch (NumberFormatException e)
        {
            errorLabel.setText("Invalid number format in \"speed\" field.");
        }
    }//GEN-LAST:event_speedTextOnFocusLost

    private void barriersTextOnFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_barriersTextOnFocusLost
        errorLabel.setText("");
        try
        {
            int newNumberOfBarriers = Integer.parseInt(barriersText.getText());
            int currentMaxNumberOfBarriers = (grid.GetHeight() * grid.GetWidth() / 10);
            if ((newNumberOfBarriers < 0) || 
                (newNumberOfBarriers > currentMaxNumberOfBarriers))
            {
                errorLabel.setText("# of barriers must be currently number 0 - " +
                    Integer.toString(currentMaxNumberOfBarriers) + ".");
            }
            else
            {
                numberOfBarriers = newNumberOfBarriers;
            }
        }
        catch (NumberFormatException e)
        {
            errorLabel.setText("Invalid number format in \"# of barriers\" field.");
        }
    }//GEN-LAST:event_barriersTextOnFocusLost

    private void barriersTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_barriersTextKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
        {
            barriersTextOnFocusLost(null);
            startButton.requestFocusInWindow();
        }
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_barriersTextKeyPressed

    private void speedTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_speedTextKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
        {
            speedTextOnFocusLost(null);
            startButton.requestFocusInWindow();
        }
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_speedTextKeyPressed

    private void heightTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_heightTextKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
        {
            heightTextOnFocusLost(null);
            startButton.requestFocusInWindow();
        }
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_heightTextKeyPressed

    private void widthTextKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_widthTextKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
        {
            widthTextOnFocusLost(null);
            startButton.requestFocusInWindow();
        }
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_widthTextKeyPressed

    private void startButtonKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_startButtonKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
            startButtonOnClick(null);
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_startButtonKeyPressed

    private void pauseButtonKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_pauseButtonKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
            pauseButtonOnClick(null);
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_pauseButtonKeyPressed

    private void stopButtonKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_stopButtonKeyPressed
        if (evt.getKeyCode() == evt.VK_ENTER)
            stopButtonOnClick(null);
        else
            formKeyPressed(evt);
    }//GEN-LAST:event_stopButtonKeyPressed

    private void formKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_formKeyPressed
        if (caterpillar != null)
        {
            int code = evt.getKeyCode();
            
            if (code == evt.VK_RIGHT)
                caterpillar.SetMoveDirection(caterpillar.TO_RIGHT);
            else if (code == evt.VK_LEFT)
                caterpillar.SetMoveDirection(caterpillar.TO_LEFT);
            else if (code == evt.VK_DOWN)
                caterpillar.SetMoveDirection(caterpillar.TO_DOWN);
            else if (code == evt.VK_UP)
                caterpillar.SetMoveDirection(caterpillar.TO_UP);
        }
        canMove = true;
    }//GEN-LAST:event_formKeyPressed

    private void pauseButtonOnClick(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_pauseButtonOnClick
        if (paused)
        {
            paused = false;
            Start();
        }
        else
        {
            paused = true;
            Stop();
        }
        SetPauseButtonLabel();
    }//GEN-LAST:event_pauseButtonOnClick

    private void SetPauseButtonLabel()
    {
        if (paused)
            pauseButton.setLabel("Resume");
        else
            pauseButton.setLabel("Pause");
    }
    
    private void stopButtonOnClick(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_stopButtonOnClick
        Stop();

        pauseButton.setEnabled(false);
        stopButton.setEnabled(false);
        startButton.setEnabled(true);
        setEnabledControls(true);
        startButton.requestFocusInWindow();
        paused = false;
        SetPauseButtonLabel();
    }//GEN-LAST:event_stopButtonOnClick

    private void startButtonOnClick(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_startButtonOnClick
        errorLabel.setText("Press a key to start a game...");
        stopButton.setEnabled(true);
        startButton.setEnabled(false);
        pauseButton.setEnabled(true);
        setEnabledControls(false);
        pauseButton.requestFocusInWindow();
        
        Graphics g = getGraphics();
        if (caterpillar != null)
            caterpillar.Delete(g);
        caterpillar = new Caterpillar(grid.GetWidth(), grid.GetHeight(), 150, errorLabel.getHeight() + errorLabel.getY(), getBackground(), grid, numberOfBarriers, g);
        caterpillar.paint(g);
        canMove = false;
        Start();
    }//GEN-LAST:event_startButtonOnClick

    private void setEnabledControls(boolean b)
    {
        widthLabel.setEnabled(b);
        widthText.setEnabled(b);
        heightLabel.setEnabled(b);
        heightText.setEnabled(b);
        speedLabel.setEnabled(b);
        speedText.setEnabled(b);
        barriersLabel.setEnabled(b);
        barriersText.setEnabled(b);
    }
    
    private void heightTextOnFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_heightTextOnFocusLost
        errorLabel.setText("");
        try
        {
            int newHeight = Integer.parseInt(heightText.getText());
            if (newHeight != grid.GetHeight())
            {
                grid.SetHeight(newHeight);
                gridResized = true;
                repaint();
            }
        }
        catch (NumberFormatException e)
        {
            errorLabel.setText("Invalid number format in \"height\" field.");
        }
        catch (IllegalArgumentException e)
        {
            errorLabel.setText("Height field: " + e.getMessage());
        }
    }//GEN-LAST:event_heightTextOnFocusLost

    private void widthTextOnFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_widthTextOnFocusLost
        errorLabel.setText("");
        try
        {
            int newWidth = Integer.parseInt(widthText.getText());
            if (newWidth != grid.GetWidth())
            {
                grid.SetWidth(newWidth);
                gridResized = true;
                repaint();
            }
        }
        catch (NumberFormatException e)
        {
            errorLabel.setText("Invalid number format in \"width\" field.");
        }
        catch (IllegalArgumentException e)
        {
            errorLabel.setText("Width field: " + e.getMessage());
        }
    }//GEN-LAST:event_widthTextOnFocusLost

    private void Start() {
        timer = new Thread(this);
        timer.start();
    }

    private void Stop() {
        timer = null;
    }

    /** <CODE>run()</CODE> method of interface <CODE>Runnable</CODE> that is implemeted
     * by this class. When caterpillar is moving, new thread that calls this method is
     * created. Cals caterpillar's <CODE>Move(Graphics)</CODE> method.
     */    
    public void run() {
        Thread me = Thread.currentThread();
        while (timer == me)
        {
            try
            {
                Thread.currentThread().sleep(caterpillarSpeedTime);
            }
            catch (InterruptedException e) {}
            
            Graphics g = getGraphics();
            if ((g != null) && canMove) // test needed, when killing applet with running
                                        // caterpillar g can be null
            {
                caterpillar.Move(g);
                errorLabel.setText("");
            }
            
            if (!caterpillar.IsCorrectHeadPosition())
            {
                stopButtonOnClick(null);
                errorLabel.setText("CRASH!!! Sorry, this is the end of the game :o)");
            }
        }
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private java.awt.Label barriersLabel;
    private java.awt.TextField barriersText;
    private java.awt.Panel controlsPanel;
    private java.awt.Label errorLabel;
    private java.awt.Label heightLabel;
    private java.awt.TextField heightText;
    private java.awt.Button pauseButton;
    private java.awt.Label speedLabel;
    private java.awt.TextField speedText;
    private java.awt.Button startButton;
    private java.awt.Button stopButton;
    private java.awt.Label widthLabel;
    private java.awt.TextField widthText;
    // End of variables declaration//GEN-END:variables
    
}
